// DO NOT EDIT
// Generated by JFlex 1.9.1 http://jflex.de/
// source: jflex/MarkerReader.jflex

/*******************************************************************************
 * Copyright (c) 2022-2029 Institute of Legal Information and Judicial Systems (IGSG-CNR)
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License. 
 * You may obtain a copy of the License at
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and 
 * limitations under the License.
 *  
 * Authors: Lorenzo Bacci (IGSG-CNR)
 ******************************************************************************/
package it.cnr.igsg.linkoln;


@SuppressWarnings("fallthrough")
class MarkerReader extends LinkolnAnnotationService {

  /** This character denotes the end of file. */
  public static final int YYEOF = -1;

  /** Initial size of the lookahead buffer. */
  private static final int ZZ_BUFFERSIZE = 16384;

  // Lexical states.
  public static final int YYINITIAL = 0;
  public static final int lkn = 2;
  public static final int inIntestazione = 4;
  public static final int inDataDoc = 6;
  public static final int inPreamble = 8;
  public static final int inText = 10;
  public static final int inParagraph = 12;
  public static final int inVirgolette = 14;
  public static final int inParole = 16;
  public static final int inList = 18;
  public static final int inListDepth1 = 20;
  public static final int inListDepth2 = 22;
  public static final int inListDepth3 = 24;

  /**
   * ZZ_LEXSTATE[l] is the state in the DFA for the lexical state l
   * ZZ_LEXSTATE[l+1] is the state in the DFA for the lexical state l
   *                  at the beginning of a line
   * l is of the form l = 2*k, k a non negative integer
   */
  private static final int ZZ_LEXSTATE[] = {
     0,  0,  1,  1,  1,  1,  2,  2,  3,  3,  4,  4,  5,  5,  6,  6, 
     7,  7,  8,  8,  9,  9, 10, 10, 11, 11
  };

  /**
   * Top-level table for translating characters to character classes
   */
  private static final int [] ZZ_CMAP_TOP = zzUnpackcmap_top();

  private static final String ZZ_CMAP_TOP_PACKED_0 =
    "\1\0\1\u0100\36\u0200\1\u0300\1\u0400\266\u0200\10\u0500\u1020\u0200";

  private static int [] zzUnpackcmap_top() {
    int [] result = new int[4352];
    int offset = 0;
    offset = zzUnpackcmap_top(ZZ_CMAP_TOP_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackcmap_top(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /**
   * Second-level tables for translating characters to character classes
   */
  private static final int [] ZZ_CMAP_BLOCKS = zzUnpackcmap_blocks();

  private static final String ZZ_CMAP_BLOCKS_PACKED_0 =
    "\11\0\1\1\1\2\1\3\1\4\1\2\22\0\1\1"+
    "\1\0\1\5\3\0\1\6\6\0\1\7\1\0\1\10"+
    "\12\11\1\12\1\13\1\14\1\15\1\16\2\0\1\17"+
    "\1\20\1\21\1\22\1\23\1\24\1\25\1\26\1\27"+
    "\1\30\1\31\1\32\1\33\1\34\1\35\1\36\1\30"+
    "\1\37\1\40\1\41\1\42\1\43\4\30\1\44\1\0"+
    "\1\45\1\0\1\30\1\0\1\46\1\47\1\50\1\51"+
    "\1\52\1\53\1\54\1\55\1\56\1\0\1\57\1\60"+
    "\1\61\1\62\1\63\1\64\1\0\1\65\1\66\1\67"+
    "\1\70\1\71\16\0\1\3\252\0\2\56\115\0\1\66"+
    "\u0182\0\1\1\45\0\2\3\u0100\0\1\57\325\0\u0100\3";

  private static int [] zzUnpackcmap_blocks() {
    int [] result = new int[1536];
    int offset = 0;
    offset = zzUnpackcmap_blocks(ZZ_CMAP_BLOCKS_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackcmap_blocks(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }

  /**
   * Translates DFA states to action switch labels.
   */
  private static final int [] ZZ_ACTION = zzUnpackAction();

  private static final String ZZ_ACTION_PACKED_0 =
    "\16\0\3\1\2\2\1\3\2\4\1\5\1\6\3\5"+
    "\1\2\3\5\7\0\1\7\1\3\70\0\1\10\10\0"+
    "\1\11\343\0\1\12\2\0\1\13\10\0\1\14\6\0"+
    "\1\15\4\0\1\16\6\0\1\17\2\0\1\20\3\0"+
    "\1\21\2\0\1\22\2\0\1\23\4\0\1\24\22\0"+
    "\1\25\2\0\1\26\20\0\1\27\25\0\1\30\1\31"+
    "\1\32\5\0\1\33\4\0\1\34\2\0\1\35\20\0"+
    "\1\36\1\0\1\37\1\40\2\0\1\10\1\41\1\42"+
    "\1\43\2\0\1\44";

  private static int [] zzUnpackAction() {
    int [] result = new int[489];
    int offset = 0;
    offset = zzUnpackAction(ZZ_ACTION_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackAction(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /**
   * Translates a state to a row index in the transition table
   */
  private static final int [] ZZ_ROWMAP = zzUnpackRowMap();

  private static final String ZZ_ROWMAP_PACKED_0 =
    "\0\0\0\72\0\164\0\256\0\350\0\u0122\0\u015c\0\u0196"+
    "\0\u01d0\0\u020a\0\u0244\0\u027e\0\u02b8\0\u02f2\0\u032c\0\u0366"+
    "\0\u03a0\0\u032c\0\u03da\0\u0414\0\u032c\0\u044e\0\u032c\0\u032c"+
    "\0\u0488\0\u04c2\0\u04fc\0\u0536\0\u0570\0\u05aa\0\u05e4\0\u061e"+
    "\0\u0658\0\u0692\0\u06cc\0\u0706\0\u0740\0\u077a\0\u032c\0\u07b4"+
    "\0\u07ee\0\u0828\0\u0862\0\u089c\0\u08d6\0\u0910\0\u094a\0\u0984"+
    "\0\u09be\0\u09f8\0\u0a32\0\u0a6c\0\u0aa6\0\u0ae0\0\u0658\0\u0b1a"+
    "\0\u0b54\0\u0b8e\0\u0bc8\0\u0c02\0\u0c3c\0\u0c76\0\u0cb0\0\u0cea"+
    "\0\u0d24\0\u0d5e\0\u0d98\0\u0dd2\0\u0e0c\0\u0e46\0\u0e80\0\u0eba"+
    "\0\u0ef4\0\u0f2e\0\u0f68\0\u0fa2\0\u0fdc\0\u1016\0\u1050\0\u108a"+
    "\0\u10c4\0\u10fe\0\u1138\0\u1172\0\u11ac\0\u11e6\0\u1220\0\u125a"+
    "\0\u1294\0\u12ce\0\u1308\0\u1342\0\u137c\0\u13b6\0\u13f0\0\u142a"+
    "\0\u032c\0\u1464\0\u149e\0\u14d8\0\u1512\0\u154c\0\u1586\0\u15c0"+
    "\0\u15fa\0\u032c\0\u1634\0\u166e\0\u16a8\0\u16e2\0\u171c\0\u1756"+
    "\0\u1790\0\u17ca\0\u1804\0\u183e\0\u1878\0\u18b2\0\u18ec\0\u1926"+
    "\0\u1960\0\u199a\0\u19d4\0\u1a0e\0\u1a48\0\u1a82\0\u1abc\0\u1af6"+
    "\0\u1b30\0\u1b6a\0\u1ba4\0\u1bde\0\u1c18\0\u1c52\0\u1c8c\0\u1cc6"+
    "\0\u1d00\0\u1d3a\0\u1d74\0\u1dae\0\u1de8\0\u1e22\0\u1e5c\0\u1e96"+
    "\0\u1ed0\0\u1f0a\0\u1f44\0\u1f7e\0\u1fb8\0\u1ff2\0\u202c\0\u2066"+
    "\0\u20a0\0\u20da\0\u2114\0\u214e\0\u2188\0\u21c2\0\u21fc\0\u2236"+
    "\0\u2270\0\u22aa\0\u22e4\0\u231e\0\u2358\0\u2392\0\u23cc\0\u2406"+
    "\0\u2440\0\u247a\0\u24b4\0\u24ee\0\u2528\0\u2562\0\u259c\0\u25d6"+
    "\0\u2610\0\u264a\0\u2684\0\u26be\0\u26f8\0\u2732\0\u276c\0\u27a6"+
    "\0\u27e0\0\u281a\0\u2854\0\u288e\0\u28c8\0\u2902\0\u293c\0\u2976"+
    "\0\u29b0\0\u29ea\0\u2a24\0\u2a5e\0\u2a98\0\u2ad2\0\u2b0c\0\u2b46"+
    "\0\u2b80\0\u2bba\0\u2bf4\0\u2c2e\0\u2c68\0\u2ca2\0\u2cdc\0\u2d16"+
    "\0\u2d50\0\u2d8a\0\u2dc4\0\u2dfe\0\u2e38\0\u2e72\0\u2eac\0\u2ee6"+
    "\0\u2f20\0\u2f5a\0\u2f94\0\u2fce\0\u3008\0\u3042\0\u307c\0\u30b6"+
    "\0\u30f0\0\u312a\0\u3164\0\u319e\0\u31d8\0\u3212\0\u324c\0\u3286"+
    "\0\u32c0\0\u32fa\0\u3334\0\u336e\0\u33a8\0\u33e2\0\u341c\0\u3456"+
    "\0\u3490\0\u34ca\0\u3504\0\u353e\0\u3578\0\u35b2\0\u35ec\0\u3626"+
    "\0\u3660\0\u369a\0\u36d4\0\u370e\0\u3748\0\u3782\0\u37bc\0\u37f6"+
    "\0\u3830\0\u386a\0\u38a4\0\u38de\0\u3918\0\u3952\0\u398c\0\u39c6"+
    "\0\u3a00\0\u3a3a\0\u3a74\0\u3aae\0\u3ae8\0\u3b22\0\u3b5c\0\u3b96"+
    "\0\u3bd0\0\u3c0a\0\u3c44\0\u3c7e\0\u3cb8\0\u3cf2\0\u3d2c\0\u3d66"+
    "\0\u3da0\0\u3dda\0\u3e14\0\u3e4e\0\u3e88\0\u3ec2\0\u3efc\0\u3f36"+
    "\0\u3f70\0\u3faa\0\u3fe4\0\u401e\0\u4058\0\u4092\0\u40cc\0\u4106"+
    "\0\u4140\0\u417a\0\u41b4\0\u41ee\0\u4228\0\u4262\0\u429c\0\u42d6"+
    "\0\u4310\0\u434a\0\u4384\0\u43be\0\u43f8\0\u4432\0\u446c\0\u44a6"+
    "\0\u44e0\0\u451a\0\u4554\0\u458e\0\u45c8\0\u4602\0\u463c\0\u4676"+
    "\0\u46b0\0\u46ea\0\u4724\0\u475e\0\u4798\0\u47d2\0\u480c\0\u4846"+
    "\0\u4880\0\u48ba\0\u48f4\0\u492e\0\u4968\0\u032c\0\u49a2\0\u49dc"+
    "\0\u032c\0\u4a16\0\u4a50\0\u4a8a\0\u4ac4\0\u4afe\0\u4b38\0\u4b72"+
    "\0\u4bac\0\u032c\0\u4be6\0\u4c20\0\u4c5a\0\u4c94\0\u4cce\0\u4d08"+
    "\0\u032c\0\u4d42\0\u4d7c\0\u4db6\0\u4df0\0\u032c\0\u4e2a\0\u4e64"+
    "\0\u4e9e\0\u4ed8\0\u4f12\0\u4f4c\0\u032c\0\u4f86\0\u4fc0\0\u032c"+
    "\0\u4ffa\0\u5034\0\u506e\0\u032c\0\u50a8\0\u50e2\0\u032c\0\u511c"+
    "\0\u5156\0\u032c\0\u5190\0\u51ca\0\u5204\0\u523e\0\u032c\0\u5278"+
    "\0\u52b2\0\u52ec\0\u5326\0\u5360\0\u539a\0\u53d4\0\u540e\0\u5448"+
    "\0\u5482\0\u54bc\0\u54f6\0\u5530\0\u556a\0\u55a4\0\u55de\0\u5618"+
    "\0\u5652\0\u032c\0\u568c\0\u56c6\0\u032c\0\u5700\0\u573a\0\u5774"+
    "\0\u57ae\0\u57e8\0\u5822\0\u585c\0\u5896\0\u58d0\0\u590a\0\u5944"+
    "\0\u597e\0\u59b8\0\u59f2\0\u5a2c\0\u5a66\0\u032c\0\u5aa0\0\u5ada"+
    "\0\u5b14\0\u5b4e\0\u5b88\0\u5bc2\0\u5bfc\0\u5c36\0\u5c70\0\u5caa"+
    "\0\u5ce4\0\u5d1e\0\u5d58\0\u5d92\0\u5dcc\0\u5e06\0\u5e40\0\u5e7a"+
    "\0\u5eb4\0\u5eee\0\u5f28\0\u032c\0\u032c\0\u032c\0\u5f62\0\u5f9c"+
    "\0\u5fd6\0\u6010\0\u604a\0\u032c\0\u6084\0\u60be\0\u60f8\0\u6132"+
    "\0\u032c\0\u616c\0\u61a6\0\u032c\0\u61e0\0\u621a\0\u6254\0\u628e"+
    "\0\u62c8\0\u6302\0\u633c\0\u6376\0\u63b0\0\u63ea\0\u6424\0\u645e"+
    "\0\u6498\0\u64d2\0\u650c\0\u6546\0\u032c\0\u6580\0\u032c\0\u032c"+
    "\0\u65ba\0\u65f4\0\u662e\0\u032c\0\u032c\0\u032c\0\u032c\0\u6668"+
    "\0\u032c";

  private static int [] zzUnpackRowMap() {
    int [] result = new int[489];
    int offset = 0;
    offset = zzUnpackRowMap(ZZ_ROWMAP_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackRowMap(String packed, int offset, int [] result) {
    int i = 0;  /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length() - 1;
    while (i < l) {
      int high = packed.charAt(i++) << 16;
      result[j++] = high | packed.charAt(i++);
    }
    return j;
  }

  /**
   * The transition table of the DFA
   */
  private static final int [] ZZ_TRANS = zzUnpacktrans();

  private static final String ZZ_TRANS_PACKED_0 =
    "\14\17\1\20\27\17\1\21\25\17\72\22\7\23\1\24"+
    "\1\23\1\24\60\23\14\25\1\26\55\25\14\27\1\30"+
    "\71\27\1\31\71\27\1\32\71\27\1\33\55\27\14\22"+
    "\1\34\55\22\14\27\1\35\71\27\1\36\71\27\1\37"+
    "\55\27\14\0\1\40\73\0\1\41\155\0\1\42\15\0"+
    "\1\43\4\0\1\44\21\0\1\43\3\0\1\44\20\0"+
    "\1\45\21\0\1\46\25\0\1\46\11\0\101\47\1\50"+
    "\1\47\1\50\60\47\10\0\1\51\15\0\1\52\26\0"+
    "\1\52\24\0\1\53\22\0\1\54\25\0\1\54\20\0"+
    "\1\55\71\0\1\56\114\0\1\57\25\0\1\57\20\0"+
    "\1\60\22\0\1\61\25\0\1\61\20\0\1\62\22\0"+
    "\1\63\25\0\1\63\20\0\1\64\22\0\1\65\25\0"+
    "\1\65\43\0\1\66\25\0\1\66\10\0\16\67\1\0"+
    "\53\67\26\0\1\43\4\0\1\70\21\0\1\43\3\0"+
    "\1\70\22\0\1\71\116\0\1\72\25\0\1\72\36\0"+
    "\1\73\25\0\1\73\42\0\1\74\25\0\1\74\21\0"+
    "\1\50\1\0\1\50\106\0\1\75\4\0\1\76\21\0"+
    "\1\75\3\0\1\76\22\0\1\77\112\0\1\100\25\0"+
    "\1\100\47\0\1\101\25\0\1\101\37\0\1\102\25\0"+
    "\1\102\43\0\1\103\25\0\1\103\47\0\1\104\25\0"+
    "\1\104\37\0\1\105\25\0\1\105\47\0\1\106\25\0"+
    "\1\106\37\0\1\107\25\0\1\107\47\0\1\110\25\0"+
    "\1\110\37\0\1\111\25\0\1\111\47\0\1\112\25\0"+
    "\1\112\43\0\1\113\25\0\1\113\43\0\1\114\25\0"+
    "\1\114\4\0\16\115\1\0\53\115\31\0\1\116\25\0"+
    "\1\116\43\0\1\117\25\0\1\117\46\0\1\120\25\0"+
    "\1\120\21\0\1\121\116\0\1\122\25\0\1\122\4\0"+
    "\16\123\1\0\17\123\1\124\25\123\1\124\5\123\37\0"+
    "\1\125\25\0\1\125\35\0\1\126\25\0\1\126\51\0"+
    "\1\127\25\0\1\127\43\0\1\130\25\0\1\130\35\0"+
    "\1\131\25\0\1\131\51\0\1\132\25\0\1\132\35\0"+
    "\1\133\25\0\1\133\51\0\1\134\25\0\1\134\35\0"+
    "\1\135\25\0\1\135\51\0\1\136\25\0\1\136\35\0"+
    "\1\137\25\0\1\137\43\0\1\140\25\0\1\140\43\0"+
    "\1\43\25\0\1\43\12\0\16\115\1\141\53\115\12\0"+
    "\1\142\113\0\1\143\25\0\1\143\21\0\1\144\115\0"+
    "\1\145\25\0\1\145\36\0\1\146\25\0\1\146\12\0"+
    "\10\123\1\147\5\123\1\0\54\123\1\150\2\123\1\150"+
    "\1\123\1\151\1\123\1\147\5\123\1\152\53\123\31\0"+
    "\1\153\25\0\1\153\24\0\1\154\110\0\1\155\25\0"+
    "\1\155\43\0\1\156\25\0\1\156\24\0\1\157\110\0"+
    "\1\160\25\0\1\160\24\0\1\161\110\0\1\162\25\0"+
    "\1\162\24\0\1\163\110\0\1\164\25\0\1\164\24\0"+
    "\1\165\71\0\1\166\57\0\16\115\1\0\3\115\1\167"+
    "\13\115\1\170\1\171\1\115\1\172\7\115\1\167\12\115"+
    "\1\170\1\171\1\115\1\172\2\115\45\0\1\141\43\0"+
    "\25\173\44\0\1\141\65\0\1\174\57\0\10\123\1\147"+
    "\5\123\1\141\53\123\16\150\1\152\53\150\10\123\1\147"+
    "\5\123\1\0\15\123\1\175\25\123\1\175\7\123\12\0"+
    "\1\176\111\0\1\177\1\0\1\200\1\0\1\201\4\0"+
    "\1\202\14\0\1\177\1\0\1\200\1\0\1\201\4\0"+
    "\1\202\12\0\1\203\71\0\1\204\111\0\1\205\1\0"+
    "\1\206\23\0\1\205\1\0\1\206\21\0\1\207\111\0"+
    "\1\210\1\0\1\211\1\0\1\212\1\0\1\213\2\0"+
    "\1\214\14\0\1\210\1\0\1\211\1\0\1\212\1\0"+
    "\1\213\2\0\1\214\12\0\1\215\113\0\1\216\1\0"+
    "\1\217\1\0\1\220\2\0\1\221\16\0\1\216\1\0"+
    "\1\217\1\0\1\220\2\0\1\221\12\0\1\222\115\0"+
    "\1\223\4\0\1\224\20\0\1\223\4\0\1\224\22\0"+
    "\1\225\26\0\1\225\20\0\16\115\1\141\1\226\26\115"+
    "\1\226\41\115\1\141\1\227\17\115\1\230\6\115\1\227"+
    "\16\115\1\230\22\115\1\141\23\115\1\231\25\115\1\231"+
    "\17\115\1\141\10\115\1\232\26\115\1\232\13\115\12\0"+
    "\1\233\4\0\25\173\64\0\1\234\25\0\1\234\5\0"+
    "\10\123\1\147\5\123\1\0\1\123\1\235\26\123\1\235"+
    "\22\123\36\0\1\236\25\0\1\236\30\0\1\237\26\0"+
    "\1\237\61\0\1\240\25\0\1\240\20\0\1\241\26\0"+
    "\1\241\52\0\1\242\26\0\1\242\56\0\1\243\25\0"+
    "\1\243\36\0\1\244\25\0\1\244\30\0\1\245\26\0"+
    "\1\245\61\0\1\246\25\0\1\246\33\0\1\247\1\0"+
    "\1\250\23\0\1\247\1\0\1\250\32\0\1\251\26\0"+
    "\1\251\61\0\1\252\25\0\1\252\20\0\1\253\26\0"+
    "\1\253\60\0\1\254\25\0\1\254\35\0\1\255\26\0"+
    "\1\255\45\0\1\256\1\0\1\257\3\0\1\260\17\0"+
    "\1\256\1\0\1\257\3\0\1\260\45\0\1\261\25\0"+
    "\1\261\20\0\1\262\26\0\1\262\60\0\1\263\25\0"+
    "\1\263\35\0\1\264\26\0\1\264\47\0\1\265\3\0"+
    "\1\266\21\0\1\265\3\0\1\266\22\0\1\267\26\0"+
    "\1\267\52\0\1\270\26\0\1\270\32\0\1\271\26\0"+
    "\1\271\23\0\16\115\1\141\22\115\1\272\25\115\1\272"+
    "\20\115\1\141\20\115\1\273\25\115\1\273\22\115\1\141"+
    "\4\115\1\274\26\115\1\274\35\115\1\141\1\115\1\275"+
    "\26\115\1\275\40\115\1\141\22\115\1\276\25\115\1\276"+
    "\2\115\2\233\1\0\2\233\1\0\4\233\1\277\31\233"+
    "\2\0\24\233\37\0\1\300\25\0\1\300\4\0\10\123"+
    "\1\147\5\123\1\0\21\123\1\301\25\123\1\301\3\123"+
    "\17\0\1\302\26\0\1\302\64\0\1\303\25\0\1\303"+
    "\35\0\1\304\25\0\1\304\47\0\1\305\25\0\1\305"+
    "\43\0\1\306\25\0\1\306\33\0\1\307\26\0\1\307"+
    "\32\0\1\310\26\0\1\310\64\0\1\311\25\0\1\311"+
    "\35\0\1\312\25\0\1\312\33\0\1\313\26\0\1\313"+
    "\61\0\1\314\25\0\1\314\42\0\1\315\25\0\1\315"+
    "\35\0\1\316\25\0\1\316\47\0\1\317\25\0\1\317"+
    "\45\0\1\320\25\0\1\320\41\0\1\321\25\0\1\321"+
    "\27\0\1\322\26\0\1\322\61\0\1\323\25\0\1\323"+
    "\36\0\1\324\25\0\1\324\41\0\1\325\25\0\1\325"+
    "\47\0\1\326\25\0\1\326\45\0\1\327\25\0\1\327"+
    "\41\0\1\330\25\0\1\330\46\0\1\331\25\0\1\331"+
    "\36\0\1\332\25\0\1\332\45\0\1\333\25\0\1\333"+
    "\43\0\1\334\25\0\1\334\45\0\1\335\25\0\1\335"+
    "\2\0\16\115\1\141\1\336\26\115\1\336\41\115\1\141"+
    "\1\337\26\115\1\337\41\115\1\141\1\340\26\115\1\340"+
    "\41\115\1\141\20\115\1\341\25\115\1\341\22\115\1\141"+
    "\16\115\1\342\25\115\1\342\6\115\11\0\1\343\103\0"+
    "\1\344\26\0\1\344\17\0\10\123\1\147\5\123\1\0"+
    "\17\123\1\345\25\123\1\345\5\123\37\0\1\346\25\0"+
    "\1\346\45\0\1\347\25\0\1\347\25\0\1\350\26\0"+
    "\1\350\54\0\1\351\25\0\1\351\33\0\1\352\26\0"+
    "\1\352\54\0\1\353\25\0\1\353\43\0\1\354\25\0"+
    "\1\354\45\0\1\355\25\0\1\355\25\0\1\356\26\0"+
    "\1\356\60\0\1\357\25\0\1\357\35\0\1\360\25\0"+
    "\1\360\51\0\1\361\25\0\1\361\25\0\1\362\26\0"+
    "\1\362\54\0\1\363\25\0\1\363\47\0\1\364\25\0"+
    "\1\364\27\0\1\365\26\0\1\365\56\0\1\366\25\0"+
    "\1\366\35\0\1\367\25\0\1\367\51\0\1\370\25\0"+
    "\1\370\25\0\1\371\26\0\1\371\54\0\1\372\25\0"+
    "\1\372\47\0\1\373\25\0\1\373\27\0\1\374\26\0"+
    "\1\374\50\0\1\375\25\0\1\375\51\0\1\376\25\0"+
    "\1\376\37\0\1\377\25\0\1\377\33\0\1\u0100\26\0"+
    "\1\u0100\34\0\1\u0101\26\0\1\u0101\23\0\16\115\1\141"+
    "\3\115\1\u0102\26\115\1\u0102\36\115\1\141\6\115\1\u0103"+
    "\26\115\1\u0103\33\115\1\141\14\115\1\u0104\25\115\1\u0104"+
    "\26\115\1\141\10\115\1\u0105\26\115\1\u0105\31\115\1\141"+
    "\13\115\1\u0106\25\115\1\u0106\11\115\11\0\1\343\33\0"+
    "\1\141\43\0\1\u0107\26\0\1\u0107\23\0\10\123\1\147"+
    "\2\123\1\150\2\123\1\0\53\123\17\0\1\u0108\26\0"+
    "\1\u0108\46\0\1\u0109\26\0\1\u0109\56\0\1\u010a\25\0"+
    "\1\u010a\36\0\1\u010b\25\0\1\u010b\46\0\1\u010c\25\0"+
    "\1\u010c\33\0\1\u010d\26\0\1\u010d\52\0\1\u010e\25\0"+
    "\1\u010e\31\0\1\u010f\26\0\1\u010f\56\0\1\u0110\25\0"+
    "\1\u0110\45\0\1\u0111\25\0\1\u0111\25\0\1\u0112\26\0"+
    "\1\u0112\42\0\1\u0113\26\0\1\u0113\56\0\1\u0114\25\0"+
    "\1\u0114\36\0\1\u0115\25\0\1\u0115\46\0\1\u0116\25\0"+
    "\1\u0116\43\0\1\u0117\25\0\1\u0117\47\0\1\u0118\25\0"+
    "\1\u0118\25\0\1\u0119\26\0\1\u0119\60\0\1\u011a\25\0"+
    "\1\u011a\41\0\1\u011b\25\0\1\u011b\36\0\1\u011c\25\0"+
    "\1\u011c\46\0\1\u011d\25\0\1\u011d\43\0\1\u011e\25\0"+
    "\1\u011e\31\0\1\u011f\26\0\1\u011f\60\0\1\u0120\25\0"+
    "\1\u0120\34\0\1\u0121\25\0\1\u0121\46\0\1\u0122\25\0"+
    "\1\u0122\30\0\1\u0123\26\0\1\u0123\20\0\16\115\1\141"+
    "\16\115\1\u0124\25\115\1\u0124\24\115\1\141\20\115\1\u0125"+
    "\25\115\1\u0125\22\115\1\141\1\115\1\u0126\26\115\1\u0126"+
    "\40\115\1\141\2\115\1\u0127\26\115\1\u0127\37\115\1\141"+
    "\16\115\1\u0128\25\115\1\u0128\6\115\33\0\1\u0129\25\0"+
    "\1\u0129\35\0\1\u012a\26\0\1\u012a\54\0\1\u012b\25\0"+
    "\1\u012b\41\0\1\u012c\25\0\1\u012c\31\0\1\u012d\26\0"+
    "\1\u012d\51\0\1\u012e\25\0\1\u012e\46\0\1\u012f\25\0"+
    "\1\u012f\40\0\1\u0130\25\0\1\u0130\50\0\1\u0131\25\0"+
    "\1\u0131\41\0\1\u0132\25\0\1\u0132\31\0\1\u0133\26\0"+
    "\1\u0133\56\0\1\u0134\25\0\1\u0134\43\0\1\u0135\25\0"+
    "\1\u0135\41\0\1\u0136\25\0\1\u0136\31\0\1\u0137\26\0"+
    "\1\u0137\53\0\1\u0138\25\0\1\u0138\41\0\1\u0139\25\0"+
    "\1\u0139\34\0\1\u013a\26\0\1\u013a\56\0\1\u013b\25\0"+
    "\1\u013b\41\0\1\u013c\25\0\1\u013c\43\0\1\u013d\25\0"+
    "\1\u013d\31\0\1\u013e\26\0\1\u013e\53\0\1\u013f\25\0"+
    "\1\u013f\41\0\1\u0140\25\0\1\u0140\50\0\1\u0141\25\0"+
    "\1\u0141\41\0\1\u0142\25\0\1\u0142\31\0\1\u0143\26\0"+
    "\1\u0143\51\0\1\u0144\25\0\1\u0144\46\0\1\u0145\25\0"+
    "\1\u0145\6\0\16\115\1\141\2\115\1\u0146\26\115\1\u0146"+
    "\37\115\1\141\1\u0147\26\115\1\u0147\41\115\1\141\16\115"+
    "\1\u0148\25\115\1\u0148\24\115\1\141\1\u0149\26\115\1\u0149"+
    "\23\115\16\u014a\1\141\53\u014a\20\0\1\u014b\26\0\1\u014b"+
    "\61\0\1\u014c\25\0\1\u014c\23\0\1\u012c\26\0\1\u012c"+
    "\23\0\16\u014d\1\0\53\u014d\16\u012d\1\u014e\53\u012d\23\0"+
    "\1\u014f\26\0\1\u014f\51\0\1\u0150\25\0\1\u0150\34\0"+
    "\1\u0151\26\0\1\u0151\36\0\1\u0152\26\0\1\u0152\23\0"+
    "\16\u0153\1\0\13\u0153\1\u0154\25\u0153\1\u0154\11\u0153\37\0"+
    "\1\u0155\25\0\1\u0155\41\0\1\u0156\25\0\1\u0156\25\0"+
    "\1\u0157\26\0\1\u0157\23\0\16\u0158\1\0\13\u0158\1\u0159"+
    "\25\u0158\1\u0159\11\u0158\16\u0137\1\u015a\53\u0137\42\0\1\u015b"+
    "\25\0\1\u015b\24\0\1\u015c\26\0\1\u015c\56\0\1\u015d"+
    "\25\0\1\u015d\41\0\1\u015e\25\0\1\u015e\42\0\1\u015f"+
    "\25\0\1\u015f\41\0\1\u0160\25\0\1\u0160\11\0\16\u013e"+
    "\1\u0161\53\u013e\42\0\1\u0162\25\0\1\u0162\24\0\1\u0163"+
    "\26\0\1\u0163\54\0\1\u0164\25\0\1\u0164\42\0\1\u0165"+
    "\25\0\1\u0165\7\0\16\u0143\1\u0166\53\u0143\23\0\1\u0167"+
    "\26\0\1\u0167\40\0\1\u0168\26\0\1\u0168\21\0\1\115"+
    "\2\u0169\1\115\1\u0169\1\115\1\u016a\7\115\1\141\71\115"+
    "\1\141\5\115\1\u016b\26\115\1\u016b\34\115\1\141\13\115"+
    "\1\u016c\25\115\1\u016c\27\115\1\u016d\53\115\16\u014a\1\u016d"+
    "\53\u014a\35\0\1\u016e\25\0\1\u016e\25\0\1\u016f\26\0"+
    "\1\u016f\23\0\16\u014d\1\u0170\53\u014d\41\0\1\u0171\25\0"+
    "\1\u0171\25\0\1\u0172\26\0\1\u0172\17\0\16\u0173\1\0"+
    "\53\u0173\16\u0153\1\u0174\71\u0153\1\u0174\1\u0175\26\u0153\1\u0175"+
    "\23\u0153\17\0\1\u0176\26\0\1\u0176\41\0\1\u0177\13\0"+
    "\1\u0178\25\0\1\u0178\11\0\16\u0179\1\0\53\u0179\16\u0158"+
    "\1\u017a\71\u0158\1\u017a\1\u017b\26\u0158\1\u017b\23\u0158\33\0"+
    "\1\u017c\25\0\1\u017c\51\0\1\u017d\25\0\1\u017d\21\0"+
    "\1\u017e\26\0\1\u017e\41\0\1\u017f\13\0\1\u0180\25\0"+
    "\1\u0180\53\0\1\u0181\25\0\1\u0181\20\0\1\u0182\26\0"+
    "\1\u0182\56\0\1\u0183\25\0\1\u0183\51\0\1\u0184\25\0"+
    "\1\u0184\34\0\1\u0185\25\0\1\u0185\53\0\1\u0186\25\0"+
    "\1\u0186\42\0\1\u0187\25\0\1\u0187\3\0\2\u0188\1\0"+
    "\1\u0188\1\0\1\u0189\63\0\1\115\2\u0169\1\115\1\u0169"+
    "\1\115\1\u016a\7\115\1\141\15\115\1\u018a\25\115\1\u018a"+
    "\25\115\1\141\15\115\1\u018b\25\115\1\u018b\25\115\1\141"+
    "\16\115\1\u018c\25\115\1\u018c\24\115\1\141\16\115\1\u018d"+
    "\25\115\1\u018d\6\115\32\0\1\u018e\25\0\1\u018e\35\0"+
    "\1\u018f\26\0\1\u018f\57\0\1\u0190\25\0\1\u0190\43\0"+
    "\1\u0191\25\0\1\u0191\2\0\16\u0173\1\u0192\53\u0173\16\u0153"+
    "\1\u0174\22\u0153\1\u0193\25\u0153\1\u0193\2\u0153\16\0\1\u0177"+
    "\72\0\1\u0194\26\0\1\u0194\23\0\16\u0179\1\u0195\53\u0179"+
    "\16\u0158\1\u017a\22\u0158\1\u0196\25\u0158\1\u0196\2\u0158\23\0"+
    "\1\u0197\26\0\1\u0197\60\0\1\u0198\25\0\1\u0198\20\0"+
    "\1\u017f\72\0\1\u0199\26\0\1\u0199\56\0\1\u019a\25\0"+
    "\1\u019a\51\0\1\u019b\25\0\1\u019b\25\0\1\u019c\26\0"+
    "\1\u019c\60\0\1\u019d\25\0\1\u019d\21\0\1\u019e\26\0"+
    "\1\u019e\56\0\1\u019f\25\0\1\u019f\51\0\1\u01a0\25\0"+
    "\1\u01a0\3\0\2\u0188\1\0\1\u0188\1\0\1\u0189\25\0"+
    "\1\u01a1\25\0\1\u01a1\43\0\1\u01a2\25\0\1\u01a2\7\0"+
    "\16\115\1\141\16\115\1\u01a3\25\115\1\u01a3\24\115\1\141"+
    "\1\115\1\u01a4\26\115\1\u01a4\22\115\16\u01a5\1\141\53\u01a5"+
    "\16\115\1\u01a6\53\115\35\0\1\u01a7\25\0\1\u01a7\43\0"+
    "\1\u01a8\25\0\1\u01a8\31\0\1\u01a9\26\0\1\u01a9\60\0"+
    "\1\u01aa\25\0\1\u01aa\2\0\16\u0153\1\u0174\10\u0153\1\u01ab"+
    "\26\u0153\1\u01ab\13\u0153\41\0\1\u01ac\25\0\1\u01ac\2\0"+
    "\16\u0158\1\u017a\10\u0158\1\u01ad\26\u0158\1\u01ad\13\u0158\37\0"+
    "\1\u01ae\25\0\1\u01ae\27\0\1\u01af\26\0\1\u01af\60\0"+
    "\1\u01b0\25\0\1\u01b0\25\0\1\u01b1\26\0\1\u01b1\46\0"+
    "\1\u01b2\26\0\1\u01b2\52\0\1\u01b3\25\0\1\u01b3\27\0"+
    "\1\u01b4\26\0\1\u01b4\60\0\1\u01b5\25\0\1\u01b5\25\0"+
    "\1\u01b6\26\0\1\u01b6\42\0\1\u01b7\26\0\1\u01b7\54\0"+
    "\1\u01b8\25\0\1\u01b8\26\0\1\u01b9\26\0\1\u01b9\22\0"+
    "\16\115\1\141\20\115\1\u01ba\25\115\1\u01ba\22\115\1\141"+
    "\21\115\1\u01bb\25\115\1\u01bb\3\115\16\u01a5\1\u01bc\53\u01a5"+
    "\16\0\1\47\71\0\1\u01bd\71\0\1\u01be\76\0\1\u01bf"+
    "\26\0\1\u01bf\17\0\16\u0153\1\u0174\15\u0153\1\u01c0\25\u0153"+
    "\1\u01c0\7\u0153\27\0\1\u01c1\26\0\1\u01c1\13\0\16\u0158"+
    "\1\u017a\15\u0158\1\u01c2\25\u0158\1\u01c2\7\u0158\35\0\1\u01c3"+
    "\25\0\1\u01c3\24\0\1\u01c4\102\0\1\u01c5\26\0\1\u01c5"+
    "\52\0\1\u01c6\25\0\1\u01c6\40\0\1\u01c7\25\0\1\u01c7"+
    "\44\0\1\u01c8\25\0\1\u01c8\24\0\1\u01c9\102\0\1\u01ca"+
    "\26\0\1\u01ca\52\0\1\u01cb\25\0\1\u01cb\22\0\1\u01cc"+
    "\112\0\1\u01cd\25\0\1\u01cd\44\0\1\u01ce\25\0\1\u01ce"+
    "\3\0\16\115\1\141\14\115\1\u01cf\25\115\1\u01cf\26\115"+
    "\1\141\17\115\1\u01d0\25\115\1\u01d0\5\115\16\0\1\u0151"+
    "\53\0\16\u0153\1\u0174\16\u0153\1\u01d1\25\u0153\1\u01d1\6\u0153"+
    "\34\0\1\u01d2\25\0\1\u01d2\7\0\16\u0158\1\u017a\16\u0158"+
    "\1\u01d3\25\u0158\1\u01d3\6\u0158\16\u01d4\1\0\53\u01d4\34\0"+
    "\1\u01c6\25\0\1\u01c6\44\0\1\u017e\25\0\1\u017e\43\0"+
    "\1\u01d5\25\0\1\u01d5\6\0\16\u01d6\1\0\53\u01d6\34\0"+
    "\1\u01cb\25\0\1\u01cb\44\0\1\u01d7\25\0\1\u01d7\41\0"+
    "\1\u01d8\25\0\1\u01d8\46\0\1\u01d9\25\0\1\u01d9\5\0"+
    "\15\115\1\u01da\1\141\66\115\1\u0169\2\115\1\141\53\115"+
    "\16\u01db\1\u0174\53\u01db\35\0\1\u0176\25\0\1\u0176\6\0"+
    "\16\u01dc\1\u017a\53\u01dc\16\u01d4\1\u01dd\53\u01d4\16\u01de\1\0"+
    "\53\u01de\16\u01d6\1\u01df\53\u01d6\16\0\1\u01e0\70\0\1\u01e1"+
    "\67\0\1\u0188\56\0\2\u01e2\3\115\11\u01e2\1\u01e3\53\u01e2"+
    "\16\u01db\1\u01e4\53\u01db\16\u01dc\1\u01e5\53\u01dc\16\u01de\1\u01e6"+
    "\53\u01de\2\u01e7\3\0\65\u01e7\16\u01e8\1\141\71\u01e8\1\0"+
    "\71\u01e8\1\u01e9\53\u01e8";

  private static int [] zzUnpacktrans() {
    int [] result = new int[26274];
    int offset = 0;
    offset = zzUnpacktrans(ZZ_TRANS_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpacktrans(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      value--;
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /** Error code for "Unknown internal scanner error". */
  private static final int ZZ_UNKNOWN_ERROR = 0;
  /** Error code for "could not match input". */
  private static final int ZZ_NO_MATCH = 1;
  /** Error code for "pushback value was too large". */
  private static final int ZZ_PUSHBACK_2BIG = 2;

  /**
   * Error messages for {@link #ZZ_UNKNOWN_ERROR}, {@link #ZZ_NO_MATCH}, and
   * {@link #ZZ_PUSHBACK_2BIG} respectively.
   */
  private static final String ZZ_ERROR_MSG[] = {
    "Unknown internal scanner error",
    "Error: could not match input",
    "Error: pushback value was too large"
  };

  /**
   * ZZ_ATTRIBUTE[aState] contains the attributes of state {@code aState}
   */
  private static final int [] ZZ_ATTRIBUTE = zzUnpackAttribute();

  private static final String ZZ_ATTRIBUTE_PACKED_0 =
    "\16\0\1\11\2\1\1\11\2\1\1\11\1\1\2\11"+
    "\7\1\7\0\1\11\1\1\16\0\1\1\51\0\1\11"+
    "\10\0\1\11\343\0\1\11\2\0\1\11\10\0\1\11"+
    "\6\0\1\11\4\0\1\11\6\0\1\11\2\0\1\11"+
    "\3\0\1\11\2\0\1\11\2\0\1\11\4\0\1\11"+
    "\22\0\1\11\2\0\1\11\20\0\1\11\25\0\3\11"+
    "\5\0\1\11\4\0\1\11\2\0\1\11\20\0\1\11"+
    "\1\0\2\11\2\0\1\1\4\11\1\0\1\11";

  private static int [] zzUnpackAttribute() {
    int [] result = new int[489];
    int offset = 0;
    offset = zzUnpackAttribute(ZZ_ATTRIBUTE_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackAttribute(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }

  /** Input device. */
  private java.io.Reader zzReader;

  /** Current state of the DFA. */
  private int zzState;

  /** Current lexical state. */
  private int zzLexicalState = YYINITIAL;

  /**
   * This buffer contains the current text to be matched and is the source of the {@link #yytext()}
   * string.
   */
  private char zzBuffer[] = new char[Math.min(ZZ_BUFFERSIZE, zzMaxBufferLen())];

  /** Text position at the last accepting state. */
  private int zzMarkedPos;

  /** Current text position in the buffer. */
  private int zzCurrentPos;

  /** Marks the beginning of the {@link #yytext()} string in the buffer. */
  private int zzStartRead;

  /** Marks the last character in the buffer, that has been read from input. */
  private int zzEndRead;

  /**
   * Whether the scanner is at the end of file.
   * @see #yyatEOF
   */
  private boolean zzAtEOF;

  /**
   * The number of occupied positions in {@link #zzBuffer} beyond {@link #zzEndRead}.
   *
   * <p>When a lead/high surrogate has been read from the input stream into the final
   * {@link #zzBuffer} position, this will have a value of 1; otherwise, it will have a value of 0.
   */
  private int zzFinalHighSurrogate = 0;

  /** For the backwards DFA of general lookahead statements */
  private boolean [] zzFin = new boolean [Math.min(ZZ_BUFFERSIZE, zzMaxBufferLen())+1];

  /** Number of newlines encountered up to the start of the matched text. */
  private int yyline;

  /** Number of characters from the last newline up to the start of the matched text. */
  private int yycolumn;

  /** Number of characters up to the start of the matched text. */
  private long yychar;

  /** Whether the scanner is currently at the beginning of a line. */
  @SuppressWarnings("unused")
  private boolean zzAtBOL = true;

  /** Whether the user-EOF-code has already been executed. */
  @SuppressWarnings("unused")
  private boolean zzEOFDone;

  /* user code: */
		
	MarkerReader() { }
	
	String inputDataDoc = null;
	
	private StringBuilder buffer = new StringBuilder();
	
	private String depth1 = null;
	private String depth2 = null;
	private String depth3 = null;
	
	private int previousState = 0;
	
	private void setDepth(String type) {
	
		if(depth1 == null) {
		
			depth1 = type;
			return;
		}
		
		if( !depth1.equals(type) && depth2 == null) {
		
			depth2 = type;
			return;
		}
		
		if( !depth2.equals(type) && depth3 == null) {
		
			depth3 = type;
			return;
		}
	}
	
	private void runLinkoln() {

		Pipeline.run(getLinkolnDocument(), buffer.toString(), position);
		addText(getLinkolnDocument().getAnnotatedText());
		position += Util.removeAllAnnotations(buffer.toString()).length();
		buffer = new StringBuilder();
	}
	
	private void readContext() {
	
		MarkerReadContext mrc = new MarkerReadContext();
			
		mrc.setLinkolnDocument(getLinkolnDocument());
		mrc.setInput(getLinkolnDocument().getAnnotatedText());

		mrc.run();
	}


  /**
   * Creates a new scanner
   *
   * @param   in  the java.io.Reader to read input from.
   */
  MarkerReader(java.io.Reader in) {
    this.zzReader = in;
  }


  /** Returns the maximum size of the scanner buffer, which limits the size of tokens. */
  private int zzMaxBufferLen() {
    return Integer.MAX_VALUE;
  }

  /**  Whether the scanner buffer can grow to accommodate a larger token. */
  private boolean zzCanGrow() {
    return true;
  }

  /**
   * Translates raw input code points to DFA table row
   */
  private static int zzCMap(int input) {
    int offset = input & 255;
    return offset == input ? ZZ_CMAP_BLOCKS[offset] : ZZ_CMAP_BLOCKS[ZZ_CMAP_TOP[input >> 8] | offset];
  }

  /**
   * Refills the input buffer.
   *
   * @return {@code false} iff there was new input.
   * @exception java.io.IOException  if any I/O-Error occurs
   */
  private boolean zzRefill() throws java.io.IOException {

    /* first: make room (if you can) */
    if (zzStartRead > 0) {
      zzEndRead += zzFinalHighSurrogate;
      zzFinalHighSurrogate = 0;
      System.arraycopy(zzBuffer, zzStartRead,
                       zzBuffer, 0,
                       zzEndRead - zzStartRead);

      /* translate stored positions */
      zzEndRead -= zzStartRead;
      zzCurrentPos -= zzStartRead;
      zzMarkedPos -= zzStartRead;
      zzStartRead = 0;
    }

    /* is the buffer big enough? */
    if (zzCurrentPos >= zzBuffer.length - zzFinalHighSurrogate && zzCanGrow()) {
      /* if not, and it can grow: blow it up */
      char newBuffer[] = new char[Math.min(zzBuffer.length * 2, zzMaxBufferLen())];
      System.arraycopy(zzBuffer, 0, newBuffer, 0, zzBuffer.length);
      zzBuffer = newBuffer;
      zzEndRead += zzFinalHighSurrogate;
      zzFinalHighSurrogate = 0;
    }

    /* fill the buffer with new input */
    int requested = zzBuffer.length - zzEndRead;
    int numRead = zzReader.read(zzBuffer, zzEndRead, requested);

    /* not supposed to occur according to specification of java.io.Reader */
    if (numRead == 0) {
      if (requested == 0) {
        throw new java.io.EOFException("Scan buffer limit reached ["+zzBuffer.length+"]");
      }
      else {
        throw new java.io.IOException(
            "Reader returned 0 characters. See JFlex examples/zero-reader for a workaround.");
      }
    }
    if (numRead > 0) {
      zzEndRead += numRead;
      if (Character.isHighSurrogate(zzBuffer[zzEndRead - 1])) {
        if (numRead == requested) { // We requested too few chars to encode a full Unicode character
          --zzEndRead;
          zzFinalHighSurrogate = 1;
        } else {                    // There is room in the buffer for at least one more char
          int c = zzReader.read();  // Expecting to read a paired low surrogate char
          if (c == -1) {
            return true;
          } else {
            zzBuffer[zzEndRead++] = (char)c;
          }
        }
      }
      /* potentially more input available */
      return false;
    }

    /* numRead < 0 ==> end of stream */
    return true;
  }


  /**
   * Closes the input reader.
   *
   * @throws java.io.IOException if the reader could not be closed.
   */
  public final void yyclose() throws java.io.IOException {
    zzAtEOF = true; // indicate end of file
    zzEndRead = zzStartRead; // invalidate buffer

    if (zzReader != null) {
      zzReader.close();
    }
  }


  /**
   * Resets the scanner to read from a new input stream.
   *
   * <p>Does not close the old reader.
   *
   * <p>All internal variables are reset, the old input stream <b>cannot</b> be reused (internal
   * buffer is discarded and lost). Lexical state is set to {@code ZZ_INITIAL}.
   *
   * <p>Internal scan buffer is resized down to its initial length, if it has grown.
   *
   * @param reader The new input stream.
   */
  public final void yyreset(java.io.Reader reader) {
    zzReader = reader;
    zzEOFDone = false;
    yyResetPosition();
    zzLexicalState = YYINITIAL;
    int initBufferSize = Math.min(ZZ_BUFFERSIZE, zzMaxBufferLen());
    if (zzBuffer.length > initBufferSize) {
      zzBuffer = new char[initBufferSize];
    }
  }

  /**
   * Resets the input position.
   */
  private final void yyResetPosition() {
      zzAtBOL  = true;
      zzAtEOF  = false;
      zzCurrentPos = 0;
      zzMarkedPos = 0;
      zzStartRead = 0;
      zzEndRead = 0;
      zzFinalHighSurrogate = 0;
      yyline = 0;
      yycolumn = 0;
      yychar = 0L;
  }


  /**
   * Returns whether the scanner has reached the end of the reader it reads from.
   *
   * @return whether the scanner has reached EOF.
   */
  public final boolean yyatEOF() {
    return zzAtEOF;
  }


  /**
   * Returns the current lexical state.
   *
   * @return the current lexical state.
   */
  public final int yystate() {
    return zzLexicalState;
  }


  /**
   * Enters a new lexical state.
   *
   * @param newState the new lexical state
   */
  public final void yybegin(int newState) {
    zzLexicalState = newState;
  }


  /**
   * Returns the text matched by the current regular expression.
   *
   * @return the matched text.
   */
  public final String yytext() {
    return new String(zzBuffer, zzStartRead, zzMarkedPos-zzStartRead);
  }


  /**
   * Returns the character at the given position from the matched text.
   *
   * <p>It is equivalent to {@code yytext().charAt(pos)}, but faster.
   *
   * @param position the position of the character to fetch. A value from 0 to {@code yylength()-1}.
   *
   * @return the character at {@code position}.
   */
  public final char yycharat(int position) {
    return zzBuffer[zzStartRead + position];
  }


  /**
   * How many characters were matched.
   *
   * @return the length of the matched text region.
   */
  public final int yylength() {
    return zzMarkedPos-zzStartRead;
  }


  /**
   * Reports an error that occurred while scanning.
   *
   * <p>In a well-formed scanner (no or only correct usage of {@code yypushback(int)} and a
   * match-all fallback rule) this method will only be called with things that
   * "Can't Possibly Happen".
   *
   * <p>If this method is called, something is seriously wrong (e.g. a JFlex bug producing a faulty
   * scanner etc.).
   *
   * <p>Usual syntax/scanner level error handling should be done in error fallback rules.
   *
   * @param errorCode the code of the error message to display.
   */
  private static void zzScanError(int errorCode) {
    String message;
    try {
      message = ZZ_ERROR_MSG[errorCode];
    } catch (ArrayIndexOutOfBoundsException e) {
      message = ZZ_ERROR_MSG[ZZ_UNKNOWN_ERROR];
    }

    throw new Error(message);
  }


  /**
   * Pushes the specified amount of characters back into the input stream.
   *
   * <p>They will be read again by then next call of the scanning method.
   *
   * @param number the number of characters to be read again. This number must not be greater than
   *     {@link #yylength()}.
   */
  public void yypushback(int number)  {
    if ( number > yylength() )
      zzScanError(ZZ_PUSHBACK_2BIG);

    zzMarkedPos -= number;
  }




  /**
   * Resumes scanning until the next regular expression is matched, the end of input is encountered
   * or an I/O-Error occurs.
   *
   * @return the next token.
   * @exception java.io.IOException if any I/O-Error occurs.
   */
  public int yylex() throws java.io.IOException
  {
    int zzInput;
    int zzAction;

    // cached fields:
    int zzCurrentPosL;
    int zzMarkedPosL;
    int zzEndReadL = zzEndRead;
    char[] zzBufferL = zzBuffer;

    int [] zzTransL = ZZ_TRANS;
    int [] zzRowMapL = ZZ_ROWMAP;
    int [] zzAttrL = ZZ_ATTRIBUTE;

    while (true) {
      zzMarkedPosL = zzMarkedPos;

      yychar+= zzMarkedPosL-zzStartRead;

      boolean zzR = false;
      int zzCh;
      int zzCharCount;
      for (zzCurrentPosL = zzStartRead  ;
           zzCurrentPosL < zzMarkedPosL ;
           zzCurrentPosL += zzCharCount ) {
        zzCh = Character.codePointAt(zzBufferL, zzCurrentPosL, zzMarkedPosL);
        zzCharCount = Character.charCount(zzCh);
        switch (zzCh) {
        case '\u000B':  // fall through
        case '\u000C':  // fall through
        case '\u0085':  // fall through
        case '\u2028':  // fall through
        case '\u2029':
          yyline++;
          yycolumn = 0;
          zzR = false;
          break;
        case '\r':
          yyline++;
          yycolumn = 0;
          zzR = true;
          break;
        case '\n':
          if (zzR)
            zzR = false;
          else {
            yyline++;
            yycolumn = 0;
          }
          break;
        default:
          zzR = false;
          yycolumn += zzCharCount;
        }
      }

      if (zzR) {
        // peek one character ahead if it is
        // (if we have counted one line too much)
        boolean zzPeek;
        if (zzMarkedPosL < zzEndReadL)
          zzPeek = zzBufferL[zzMarkedPosL] == '\n';
        else if (zzAtEOF)
          zzPeek = false;
        else {
          boolean eof = zzRefill();
          zzEndReadL = zzEndRead;
          zzMarkedPosL = zzMarkedPos;
          zzBufferL = zzBuffer;
          if (eof)
            zzPeek = false;
          else
            zzPeek = zzBufferL[zzMarkedPosL] == '\n';
        }
        if (zzPeek) yyline--;
      }
      zzAction = -1;

      zzCurrentPosL = zzCurrentPos = zzStartRead = zzMarkedPosL;

      zzState = ZZ_LEXSTATE[zzLexicalState];

      // set up zzAction for empty match case:
      int zzAttributes = zzAttrL[zzState];
      if ( (zzAttributes & 1) == 1 ) {
        zzAction = zzState;
      }


      zzForAction: {
        while (true) {

          if (zzCurrentPosL < zzEndReadL) {
            zzInput = Character.codePointAt(zzBufferL, zzCurrentPosL, zzEndReadL);
            zzCurrentPosL += Character.charCount(zzInput);
          }
          else if (zzAtEOF) {
            zzInput = YYEOF;
            break zzForAction;
          }
          else {
            // store back cached positions
            zzCurrentPos  = zzCurrentPosL;
            zzMarkedPos   = zzMarkedPosL;
            boolean eof = zzRefill();
            // get translated positions and possibly new buffer
            zzCurrentPosL  = zzCurrentPos;
            zzMarkedPosL   = zzMarkedPos;
            zzBufferL      = zzBuffer;
            zzEndReadL     = zzEndRead;
            if (eof) {
              zzInput = YYEOF;
              break zzForAction;
            }
            else {
              zzInput = Character.codePointAt(zzBufferL, zzCurrentPosL, zzEndReadL);
              zzCurrentPosL += Character.charCount(zzInput);
            }
          }
          int zzNext = zzTransL[ zzRowMapL[zzState] + zzCMap(zzInput) ];
          if (zzNext == -1) break zzForAction;
          zzState = zzNext;

          zzAttributes = zzAttrL[zzState];
          if ( (zzAttributes & 1) == 1 ) {
            zzAction = zzState;
            zzMarkedPosL = zzCurrentPosL;
            if ( (zzAttributes & 8) == 8 ) break zzForAction;
          }

        }
      }

      // store back cached position
      zzMarkedPos = zzMarkedPosL;

      if (zzInput == YYEOF && zzStartRead == zzCurrentPos) {
        zzAtEOF = true;
            switch (zzLexicalState) {
            case inPreamble: {
              System.err.println("Linkoln error - MarkerReader - Unbalanced <mrk:preambolo>");
		return YYEOF;
            }  // fall though
            case 490: break;
            case inText: {
              System.err.println("Linkoln error - MarkerReader - Unbalanced <mrk:titoloDoc>, <mrk:rubrica> or <h:p>");
		return YYEOF;
            }  // fall though
            case 491: break;
            case inParagraph: {
              System.err.println("Linkoln error - MarkerReader - Unbalanced <mrk:paragrafo>");
		
		return YYEOF;
            }  // fall though
            case 492: break;
            case inVirgolette: {
              System.err.println("Linkoln error - MarkerReader - Unbalanced <mrk:virgolette>");
		
		return YYEOF;
            }  // fall though
            case 493: break;
            case inParole: {
              System.err.println("Linkoln error - MarkerReader - Unbalanced <mrk:parole>");
		
		return YYEOF;
            }  // fall though
            case 494: break;
            default:
        return YYEOF;
        }
      }
      else {
        switch (zzAction < 0 ? zzAction : ZZ_ACTION[zzAction]) {
          case 1:
            { addText();
	position++;
            }
          // fall through
          case 37: break;
          case 2:
            { System.out.print(yytext());
            }
          // fall through
          case 38: break;
          case 3:
            { inputDataDoc = yytext();
		getLinkolnDocument().setInputDate(inputDataDoc);
            }
          // fall through
          case 39: break;
          case 4:
            { addText();
		position++;
            }
          // fall through
          case 40: break;
          case 5:
            { buffer.append(yytext());
            }
          // fall through
          case 41: break;
          case 6:
            { //System.out.println("inText buffer: " + buffer.toString());
		
		yypushback(1);
		runLinkoln();	
		addText();
		yybegin(previousState);
            }
          // fall through
          case 42: break;
          case 7:
            { addText();
		yybegin(0);
            }
          // fall through
          case 43: break;
          case 8:
            { addText();
            }
          // fall through
          case 44: break;
          case 9:
            { //System.out.println("IN P-START: " + yytext());
		
		addText();
		buffer = new StringBuilder();
		previousState = inPreamble;
		yybegin(inText);
            }
          // fall through
          case 45: break;
          case 10:
            { runLinkoln();
		readContext();
		
		previousState = inParagraph;
		getLinkolnDocument().contextSkip = true;
		
		addText();
		yybegin(inParole);
            }
          // fall through
          case 46: break;
          case 11:
            { runLinkoln();	

		addText();
		
		getLinkolnDocument().contextSkip = false;
		
		yybegin(previousState);
            }
          // fall through
          case 47: break;
          case 12:
            { runLinkoln();
		readContext();
		
		previousState = inListDepth1;
		getLinkolnDocument().contextSkip = true;
		
		addText();		
		yybegin(inParole);
            }
          // fall through
          case 48: break;
          case 13:
            { runLinkoln();
		readContext();
		
		previousState = inListDepth2;
		getLinkolnDocument().contextSkip = true;
		
		addText();		
		yybegin(inParole);
            }
          // fall through
          case 49: break;
          case 14:
            { runLinkoln();
		readContext();
		
		previousState = inListDepth3;
		getLinkolnDocument().contextSkip = true;
		
		addText();		
		yybegin(inParole);
            }
          // fall through
          case 50: break;
          case 15:
            { addText();
	buffer = new StringBuilder();
	previousState = 0;
	yybegin(inText);
            }
          // fall through
          case 51: break;
          case 16:
            { runLinkoln();
		readContext();
				
		yypushback(yylength());
		
		depth1 = null;
		depth2 = null;
		depth3 = null;
		
		yybegin(inList);
            }
          // fall through
          case 52: break;
          case 17:
            { depth1 = "number";
		addText();
		yybegin(inListDepth1);
            }
          // fall through
          case 53: break;
          case 18:
            { runLinkoln();
		
		addText();
		
		yybegin(inParagraph);
            }
          // fall through
          case 54: break;
          case 19:
            { runLinkoln();
		/* if(getLinkolnDocument().contextReference == null) */ readContext();
		depth2 = "number";
		addText();
		yybegin(inListDepth2);
            }
          // fall through
          case 55: break;
          case 20:
            { runLinkoln();
		
		addText();
		
		yybegin(inListDepth1);
            }
          // fall through
          case 56: break;
          case 21:
            { depth1 = "letter";
		addText();
		yybegin(inListDepth1);
            }
          // fall through
          case 57: break;
          case 22:
            { runLinkoln();
		/* if(getLinkolnDocument().contextReference == null) */ readContext();
		depth2 = "letter";
		addText();
		yybegin(inListDepth2);
            }
          // fall through
          case 58: break;
          case 23:
            { //System.out.println("IN PRAMBLE: " + yytext());
	
	addText();
	yybegin(inPreamble);
            }
          // fall through
          case 59: break;
          case 24:
            { addText();
	
	buffer = new StringBuilder();
	
	getLinkolnDocument().resetContext();
	
	previousState = 0;
	
	yybegin(inParagraph);
            }
          // fall through
          case 60: break;
          case 25:
            { Pipeline.run(getLinkolnDocument(), buffer.toString(), position);
		readContext();
		runLinkoln(); //Lancia di nuovo per eventuali partizioni di modifica sparse nel paragrafo	
		
		addText();
		
		yybegin(0);
            }
          // fall through
          case 61: break;
          case 26:
            { runLinkoln();
		readContext();
		
		previousState = inParagraph;
		getLinkolnDocument().contextSkip = true;
		
		addText();
		yybegin(inVirgolette);
            }
          // fall through
          case 62: break;
          case 27:
            { runLinkoln();
		readContext();
		
		previousState = inListDepth1;
		getLinkolnDocument().contextSkip = true;
		
		addText();		
		yybegin(inVirgolette);
            }
          // fall through
          case 63: break;
          case 28:
            { runLinkoln();
		readContext();
		
		previousState = inListDepth2;
		getLinkolnDocument().contextSkip = true;
		
		addText();		
		yybegin(inVirgolette);
            }
          // fall through
          case 64: break;
          case 29:
            { runLinkoln();
		readContext();
		
		previousState = inListDepth3;
		getLinkolnDocument().contextSkip = true;
		
		addText();		
		yybegin(inVirgolette);
            }
          // fall through
          case 65: break;
          case 30:
            { runLinkoln();
		/* if(getLinkolnDocument().contextReference == null) */ readContext();
		depth2 = "subnumber";
		addText();
		yybegin(inListDepth2);
            }
          // fall through
          case 66: break;
          case 31:
            { runLinkoln();
		depth3 = "subnumber";
		addText();
		yybegin(inListDepth3);
            }
          // fall through
          case 67: break;
          case 32:
            { runLinkoln();
		
		addText();
		
		yybegin(inListDepth2);
            }
          // fall through
          case 68: break;
          case 33:
            { depth1 = "latin";
		addText();
		yybegin(inListDepth1);
            }
          // fall through
          case 69: break;
          case 34:
            { runLinkoln();
		readContext();
		depth2 = "latin";
		addText();
		yybegin(inListDepth2);
            }
          // fall through
          case 70: break;
          case 35:
            { runLinkoln();
		depth3 = "latin";
		addText();
		yybegin(inListDepth3);
            }
          // fall through
          case 71: break;
          case 36:
            // general lookahead, find correct zzMarkedPos
            { int zzFState = 12;
              int zzFPos = zzStartRead;
              if (zzFin.length <= zzBufferL.length) {
                zzFin = new boolean[zzBufferL.length+1];
              }
              boolean zzFinL[] = zzFin;
              while (zzFState != -1 && zzFPos < zzMarkedPos) {
                zzFinL[zzFPos] = ((zzAttrL[zzFState] & 1) == 1);
                zzInput = Character.codePointAt(zzBufferL, zzFPos, zzMarkedPos);
                zzFPos += Character.charCount(zzInput);
                zzFState = zzTransL[ zzRowMapL[zzFState] + zzCMap(zzInput) ];
              }
              if (zzFState != -1) {
                zzFinL[zzFPos++] = ((zzAttrL[zzFState] & 1) == 1);
              }
              while (zzFPos <= zzMarkedPos) {
                zzFinL[zzFPos++] = false;
              }

              zzFState = 13;
              zzFPos = zzMarkedPos;
              while (!zzFinL[zzFPos] || (zzAttrL[zzFState] & 1) != 1) {
                zzInput = Character.codePointBefore(zzBufferL, zzFPos, zzStartRead);
                zzFPos -= Character.charCount(zzInput);
                zzFState = zzTransL[ zzRowMapL[zzFState] + zzCMap(zzInput) ];
              };
              zzMarkedPos = zzFPos;
            }
            { addText();
	
	if(inputDataDoc == null) yybegin(inDataDoc);
            }
          // fall through
          case 72: break;
          default:
            zzScanError(ZZ_NO_MATCH);
        }
      }
    }
  }

  /**
   * Runs the scanner on input files.
   *
   * This is a standalone scanner, it will print any unmatched
   * text to System.out unchanged.
   *
   * @param argv   the command line, contains the filenames to run
   *               the scanner on.
   */
  public static void main(String[] argv) {
    if (argv.length == 0) {
      System.out.println("Usage : java MarkerReader [ --encoding <name> ] <inputfile(s)>");
    }
    else {
      int firstFilePos = 0;
      String encodingName = "UTF-8";
      if (argv[0].equals("--encoding")) {
        firstFilePos = 2;
        encodingName = argv[1];
        try {
          // Side-effect: is encodingName valid?
          java.nio.charset.Charset.forName(encodingName);
        } catch (Exception e) {
          System.out.println("Invalid encoding '" + encodingName + "'");
          return;
        }
      }
      for (int i = firstFilePos; i < argv.length; i++) {
        MarkerReader scanner = null;
        java.io.FileInputStream stream = null;
        java.io.Reader reader = null;
        try {
          stream = new java.io.FileInputStream(argv[i]);
          reader = new java.io.InputStreamReader(stream, encodingName);
          scanner = new MarkerReader(reader);
          while ( !scanner.zzAtEOF ) scanner.yylex();
        }
        catch (java.io.FileNotFoundException e) {
          System.out.println("File not found : \""+argv[i]+"\"");
        }
        catch (java.io.IOException e) {
          System.out.println("IO error scanning file \""+argv[i]+"\"");
          System.out.println(e);
        }
        catch (Exception e) {
          System.out.println("Unexpected exception:");
          e.printStackTrace();
        }
        finally {
          if (reader != null) {
            try {
              reader.close();
            }
            catch (java.io.IOException e) {
              System.out.println("IO error closing file \""+argv[i]+"\"");
              System.out.println(e);
            }
          }
          if (stream != null) {
            try {
              stream.close();
            }
            catch (java.io.IOException e) {
              System.out.println("IO error closing file \""+argv[i]+"\"");
              System.out.println(e);
            }
          }
        }
      }
    }
  }


}
